# CfnContainerGroupDefinition

The properties that describe a container group resource.

You can update all properties of a container group definition properties. Updates to a container group definition are saved as new versions.

*Used with:* [CreateContainerGroupDefinition](https://docs.aws.amazon.com/gamelift/latest/apireference/API_CreateContainerGroupDefinition.html)

*Returned by:* [DescribeContainerGroupDefinition](https://docs.aws.amazon.com/gamelift/latest/apireference/API_DescribeContainerGroupDefinition.html) , [ListContainerGroupDefinitions](https://docs.aws.amazon.com/gamelift/latest/apireference/API_ListContainerGroupDefinitions.html) , [UpdateContainerGroupDefinition](https://docs.aws.amazon.com/gamelift/latest/apireference/API_UpdateContainerGroupDefinition.html)

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnContainerGroupDefinition
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IContainerGroupDefinitionRef, IConstruct, IDependable

- CloudFormation: [`AWS::GameLift::ContainerGroupDefinition`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-gamelift-containergroupdefinition.html)
- Source: Generated code
- Type last changed: v2.273.0 · 8 Oct 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_gamelift as gamelift } from 'aws-cdk-lib';
const cfnContainerGroupDefinition = new gamelift.CfnContainerGroupDefinition(this, 'MyCfnContainerGroupDefinition', {
  name: 'name',
  operatingSystem: 'operatingSystem',
  totalMemoryLimitMebibytes: 123,

  // the properties below are optional
  containerGroupType: 'containerGroupType',
  gameServerContainerDefinition: {
    containerName: 'containerName',
    imageUri: 'imageUri',
    serverSdkVersion: 'serverSdkVersion',

    // the properties below are optional
    dependsOn: [{
      condition: 'condition',
      containerName: 'containerName',
    }],
    environmentOverride: [{
      name: 'name',
      value: 'value',
    }],
    linuxCapabilities: {
      include: ['include'],
    },
    mountPoints: [{
      instancePath: 'instancePath',

      // the properties below are optional
      accessLevel: 'accessLevel',
      containerPath: 'containerPath',
    }],
    portConfiguration: {
      containerPortRanges: [{
        fromPort: 123,
        protocol: 'protocol',
        toPort: 123,
      }],
    },
    resolvedImageDigest: 'resolvedImageDigest',
    vcpu: 123,
  },
  sourceVersionNumber: 123,
  supportContainerDefinitions: [{
    containerName: 'containerName',
    imageUri: 'imageUri',

    // the properties below are optional
    dependsOn: [{
      condition: 'condition',
      containerName: 'containerName',
    }],
    environmentOverride: [{
      name: 'name',
      value: 'value',
    }],
    essential: false,
    healthCheck: {
      command: ['command'],

      // the properties below are optional
      interval: 123,
      retries: 123,
      startPeriod: 123,
      timeout: 123,
    },
    linuxCapabilities: {
      include: ['include'],
    },
    memoryHardLimitMebibytes: 123,
    mountPoints: [{
      instancePath: 'instancePath',

      // the properties below are optional
      accessLevel: 'accessLevel',
      containerPath: 'containerPath',
    }],
    portConfiguration: {
      containerPortRanges: [{
        fromPort: 123,
        protocol: 'protocol',
        toPort: 123,
      }],
    },
    resolvedImageDigest: 'resolvedImageDigest',
    vcpu: 123,
  }],
  tags: [{
    key: 'key',
    value: 'value',
  }],
  totalVcpuLimit: 123,
  versionDescription: 'versionDescription',
});
```

## Initializer

```ts
new CfnContainerGroupDefinition(scope: Construct, id: string, props: CfnContainerGroupDefinitionProps)
```

## Construct Props

- `containerGroupType`: string — The type of container group.

  Container group type determines how Amazon GameLift Servers deploys the container group on each fleet instance.

- `gameServerContainerDefinition`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnContainerGroupDefinition.GameServerContainerDefinitionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_gamelift.CfnContainerGroupDefinition.GameServerContainerDefinitionProperty.html) — The definition for the game server container in this group.

  This property is used only when the container group type is `GAME_SERVER` . This container definition specifies a container image with the game server build.

- `name`: string (required) — A descriptive identifier for the container group definition.

  The name value is unique in an AWS Region.

- `operatingSystem`: string (required) — The platform that all containers in the container group definition run on.

  > Amazon Linux 2 (AL2) will reach end of support on 6/30/2026. See more details in the [Amazon Linux 2 FAQs](https://docs.aws.amazon.com/amazon-linux-2/faqs/) . For game servers that are hosted on AL2 and use server SDK version 4.x for Amazon GameLift Servers, first update the game server build to server SDK 5.x, and then deploy to AL2023 instances. See [Migrate to server SDK version 5.](https://docs.aws.amazon.com/gamelift/latest/developerguide/reference-serversdk5-migration.html)

- `sourceVersionNumber`: number — A specific ContainerGroupDefinition version to be updated.

- `supportContainerDefinitions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnContainerGroupDefinition.SupportContainerDefinitionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_gamelift.CfnContainerGroupDefinition.SupportContainerDefinitionProperty.html)[] — The set of definitions for support containers in this group.

  A container group definition might have zero support container definitions. Support container can be used in any type of container group.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An array of key-value pairs to apply to this resource.

- `totalMemoryLimitMebibytes`: number (required) — The amount of memory (in MiB) on a fleet instance to allocate for the container group.

  All containers in the group share these resources.

  You can set a limit for each container definition in the group. If individual containers have limits, this total value must be greater than any individual container's memory limit.

- `totalVcpuLimit`: number — The amount of vCPU units on a fleet instance to allocate for the container group (1 vCPU is equal to 1024 CPU units).

  All containers in the group share these resources. You can set a limit for each container definition in the group. If individual containers have limits, this total value must be equal to or greater than the sum of the limits for each container in the group.

- `versionDescription`: string — An optional description that was provided for a container group definition update.

  Each version can have a unique description.

## Properties

- `attrContainerGroupDefinitionArn`: string — The Amazon Resource Name ( [ARN](https://docs.aws.amazon.com/AmazonS3/latest/dev/s3-arn-format.html) ) that is assigned to an Amazon GameLift Servers `ContainerGroupDefinition` resource. It uniquely identifies the resource across all AWS Regions. Format is `arn:aws:gamelift:[region]::containergroupdefinition/[container group definition name]:[version]` .

- `attrCreationTime`: string — A time stamp indicating when this data object was created.

  Format is a number expressed in Unix time as milliseconds (for example `"1469498468.057"` ).

- `attrStatus`: string — Current status of the container group definition resource. Values include:.

  - `COPYING` -- Amazon GameLift Servers is in the process of making copies of all container images that are defined in the group. While in this state, the resource can't be used to create a container fleet.
  - `READY` -- Amazon GameLift Servers has copied the registry images for all containers that are defined in the group. You can use a container group definition in this status to create a container fleet.
  - `FAILED` -- Amazon GameLift Servers failed to create a valid container group definition resource. For more details on the cause of the failure, see `StatusReason` . A container group definition resource in failed status will be deleted within a few minutes.

- `attrStatusReason`: string — Additional information about a container group definition that's in `FAILED` status. Possible reasons include:.

  - An internal issue prevented Amazon GameLift Servers from creating the container group definition resource. Delete the failed resource and call [CreateContainerGroupDefinition](https://docs.aws.amazon.com/gamelift/latest/apireference/API_CreateContainerGroupDefinition.html) again.
  - An access-denied message means that you don't have permissions to access the container image on ECR. See [IAM permission examples](https://docs.aws.amazon.com/gamelift/latest/developerguide/gamelift-iam-policy-examples.html.html) for help setting up required IAM permissions for Amazon GameLift Servers.
  - The `ImageUri` value for at least one of the containers in the container group definition was invalid or not found in the current AWS account.
  - At least one of the container images referenced in the container group definition exceeds the allowed size. For size limits, see [Amazon GameLift Servers endpoints and quotas](https://docs.aws.amazon.com/general/latest/gr/gamelift.html) .
  - At least one of the container images referenced in the container group definition uses a different operating system than the one defined for the container group.

- `attrVersionNumber`: number — Indicates the version of a particular container group definition.

  This number is incremented automatically when you update a container group definition. You can view, update, or delete individual versions or the entire container group definition.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `containerGroupDefinitionRef`: [ContainerGroupDefinitionReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_gamelift.ContainerGroupDefinitionReference.html) — A reference to a ContainerGroupDefinition resource.

- `containerGroupType`: string — The type of container group.

- `creationStack`: string[]

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `gameServerContainerDefinition`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnContainerGroupDefinition.GameServerContainerDefinitionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_gamelift.CfnContainerGroupDefinition.GameServerContainerDefinitionProperty.html) — The definition for the game server container in this group.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `name`: string — A descriptive identifier for the container group definition.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `operatingSystem`: string — The platform that all containers in the container group definition run on.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `sourceVersionNumber`: number — A specific ContainerGroupDefinition version to be updated.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `supportContainerDefinitions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnContainerGroupDefinition.SupportContainerDefinitionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_gamelift.CfnContainerGroupDefinition.SupportContainerDefinitionProperty.html)[] — The set of definitions for support containers in this group.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An array of key-value pairs to apply to this resource.

- `totalMemoryLimitMebibytes`: number — The amount of memory (in MiB) on a fleet instance to allocate for the container group.

- `totalVcpuLimit`: number — The amount of vCPU units on a fleet instance to allocate for the container group (1 vCPU is equal to 1024 CPU units).

- `versionDescription`: string — An optional description that was provided for a container group definition update.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForContainerGroupDefinition(resource: IContainerGroupDefinitionRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnContainerGroupDefinition(x: any): boolean` (static) — Checks whether the given object is a CfnContainerGroupDefinition.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
